<?php require "../../../../vendor/autoload.php";
/************************************************************
 * Process a Sale through eprocessingnetwork.com API
 * Record transaction in db
 * Update operator with status and adjustment
 ************************************************************/
    //ini_set('display_errors', 1); 
    //ini_set('display_startup_errors', 1); 
    //error_reporting(E_ALL); 
    $dotenv = Dotenv\Dotenv::createImmutable("../../../../");
    $dotenv->load();
    
    $connection = $_ENV['DB_CONNECTION'];
    $host       = $_ENV['DB_HOST'];
    $port       = $_ENV['DB_PORT'];
    $db         = $_ENV['DB_DATABASE'];
    $user       = $_ENV['DB_USERNAME'];
    $pass       = $_ENV['DB_PASSWORD'];


    if (isset($_POST['Total']) &&
        isset($_POST['Address']) &&
        isset($_POST['Zip']) &&
        isset($_POST['CardNo']) &&
        isset($_POST['ExpMonth']) &&
        isset($_POST['ExpYear']) &&
        isset($_POST['CVV2']) 
        ) {
        
        $gateway_id = 1;
        $hall_id = 1;
        $loyalty_card = $_POST['LoyaltyCardNo'];
        $player_id    = $_POST['PlayerId'];
        $total        = $_POST['Total'];
        $address      = $_POST['Address'];
        $zip          = $_POST['Zip'];
        $cardNo       = $_POST['CardNo'];
        $expMonth     = $_POST['ExpMonth'];
        $expYear      = $_POST['ExpYear'];
        $cvv2         = $_POST['CVV2'];
        $referrerURL  = $_POST['ReferrerURL'];
        // optional guys
        $firstName    = $_POST['FirstName'];
        $lastName     = $_POST['LastName'];
        $city         = $_POST['City'];
        $state        = $_POST['State'];
        $phone        = $_POST['PhoneNumber'];
        $email        = $_POST['Email'];
        
        if($total < 5 || 
            strlen($address)<3 || 
            strlen($zip)<3 || 
            strlen($cardNo)<12 || 
            strlen($expMonth) <2 || 
            strlen($expYear) < 4 || 
            strlen($cvv2)<3 || 
            strlen($loyalty_card) <3 ) {
          
          $fail =1 ;
          // check cc card
        }
        $data = array(
            "ePNAccount"  => $_ENV['EPN_ACCOUNT'],
            "RestrictKey" => $_ENV['EPN_RESTRICT_KEY'],
            "RequestType" => "transaction",
            "TranType"    => "Sale",
            "Total"       => $total,
            "Address"     => $address,
            "Zip"         => $zip,
            "CardNo"      => $cardNo,
            "ExpMonth"    => $expMonth,
            "ExpYear"     => $expYear,
            "CVV2Type"    => "1",
            "CVV2"        => $cvv2
        );
        $ReferrerURL = $_POST['ReferrerURL'];
        // TODO!!!
        // reject special chars in any field
        // card, zip, cvv are numbers only
        // exp month and year are valid
        // check data array for null values and reject
        // mod 10 Card No
        // regex Card No for type and reject unaccepted types
        // AVS on Card and Zip
        // check optional fields
        // make sure email doesn't have ; and is no more than a set length
        // should we drop if anything wrong with it
        // email customer on success

        $json_params = json_encode($data);

        // Initiate cURL w/ protocol & URL of remote host
        $ch = curl_init('https://www.eprocessingnetwork.com/cgi-bin/epn/secure/tdbe/transact.pl');
        curl_setopt($ch, CURLOPT_POST, 1);

        // Force requsts to use TLS 1.2
        curl_setopt($ch, CURLOPT_SSLVERSION, 6);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        // Set the Content-Type header and XML Post fields
        curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/json"));
        curl_setopt($ch, CURLOPT_POSTFIELDS, $json_params);

        // Execute the post
        $output = curl_exec($ch);
        echo $output;            
        //Close curl
        curl_close($ch);
        // now we need to parse the output to determine if it is a success or fail
        // if success tell server

        $json = json_decode($output, true);
        if( $json['Success'] == 'Y') {
          // so we need to do another curl post to our own server now

          $headers = [
            'Content-Type: application/json'
            , 'CustomerApiKey: Kroau0N7puR0YGgUe3m7MKo3SBuCcfeuIwu0MADqpkrhkCP5jRo3vHnKcDKK'
            , 'Token: eSIaLboHCLsbIKBfnhnhYM2pQkqGDrr1a5Mh7MBf4xGQRtZtgLEAEKUwWQHk'
            , 'Tokentype: AdminToken'
          ];
          $input = array (
            "Amount" => $total
            , "PaymentType" => "Card"
            , 'PinNumber' => '123456'
            , 'Type' => 'deposit'
            , 'employeeFromSignature' => 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAAAXNSR0IArs4c6QAAAA1JREFUGFdj+NK1+j8AB8gDKdSM4ecAAAAASUVORK5CYII='
            , 'employeeId' => '20'
            , 'employeeToSignature' => 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAAAXNSR0IArs4c6QAAAA1JREFUGFdj+NK1+j8AB8gDKdSM4ecAAAAASUVORK5CYII='
            , 'otherComponent' => 'true'
            , 'LoyaltyCardNo' => $loyalty_card
            , 'playerId' => $player_id
            , 'TransactionInfo' => $output
          ); 

          $json_params = json_encode($input);
          $ch = curl_init('http://bingodemos.com/cliff/backend/public/index.php/api/v1/setup/user/payment');
          curl_setopt($ch, CURLOPT_POST, 1);

          curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  
          curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
          curl_setopt($ch, CURLOPT_POSTFIELDS, $json_params);
          // Execute the post
          $final = curl_exec($ch);
          //Close curl
          curl_close($ch);

          // write to db
          $dsn = $connection.":host=".$host.";dbname=".$db.";charset=utf8";      
          $options = [
            PDO::ATTR_ERRMODE            => PDO::ERRMODE_EXCEPTION,
            PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_ASSOC,
            PDO::ATTR_EMULATE_PREPARES   => false,
          ];
          $pdo = new PDO($dsn, $user, $pass, $options);
          $pdo->prepare("INSERT INTO user_transactions (
            gateway_id
            , hall_id
            , loyalty_card
            , repurchase_id
            , transaction_type_id
            , total
            , auth_code
            , invoice
            , response
            , result
            , transaction_token
          )
          VALUES (
            :gateway_id
            , :hall_id
            , :loyalty_card
            , :repurchase_id
            , :transaction_type_id
            , :total
            , :auth_code
            , :invoice
            , :response
            , :result
            , :transaction_token
          ) ")
          ->execute([
            'gateway_id'            => 1
            , 'hall_id'             => 1
            , 'loyalty_card'        => $loyalty_card
            , 'repurchase_id'       => $json['XactID']
            , 'transaction_type_id' => 1
            , 'total'               => $total
            , 'auth_code'           => $json['AuthCode']
            , 'invoice'             => $json['Invoice']
            , 'response'            => $json['RespText']
            , 'result'              => $json['Success']
            , 'transaction_token'   => $json['Tran_token']
          ]);

          // email client

      }

    } else {
        // missing some sort of data
        // build a get query string and send back to referrerURL
        echo "Cliff here with missing post vals";
        print_r( $_POST );
        
    }

    /* Luhn algorithm number checker - (c) 2005-2008 shaman - www.planzero.org *
     * This code has been released into the public domain, however please      *
     * give credit to the original author where possible.                      */
    function luhn_check($number) {
    
      // Strip any non-digits (useful for credit card numbers with spaces and hyphens)
      $number=preg_replace('/\D/', '', $number);
    
      // Set the string length and parity
      $number_length=strlen($number);
      $parity=$number_length % 2;
    
      // Loop through each digit and do the maths
      $total=0;
      for ($i=0; $i<$number_length; $i++) {
        $digit=$number[$i];
        // Multiply alternate digits by two
        if ($i % 2 == $parity) {
          $digit*=2;
          // If the sum is two digits, add them together (in effect)
          if ($digit > 9) {
            $digit-=9;
          }
        }
        // Total up the digits
        $total+=$digit;
      }
    
      // If the total mod 10 equals 0, the number is valid
      return ($total % 10 == 0) ? TRUE : FALSE;
    
    }
?>

